package com.jbergin.calculator;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

public class CalculatorTest {

	private CalculatorModel calculator;
	
	@Before
	public void setUp() throws Exception {
		calculator = new CalculatorModel();
	}
	
	@Test
	public void testInitialDisplay(){
		assertEquals(0, calculator.display());
	}
	
	@Test
	public void testSimpleKeyPressFive(){
		calculator.pressFive();
		assertEquals(5, calculator.display());
	}

	@Test
	public void testSimpleKeyPressThree(){
		calculator.pressThree();
		assertEquals(3, calculator.display());
	}
	
	@Test 
	public void testMultipleNumericPress(){
		calculator.pressFive();
		assertEquals(5, calculator.display());
		calculator.pressThree();
		assertEquals(53, calculator.display());
		calculator.pressFive();
		assertEquals(535, calculator.display());
	}
	
	@Test
	public void testPlusKey(){
		calculator.pressFive();
		calculator.pressThree();
		calculator.pressPlus();
		assertEquals(53, calculator.display());
		calculator.pressThree();
		assertEquals(3, calculator.display());
		calculator.pressFive();
		assertEquals(35, calculator.display());		
	}
	
	@Test
	public void testSimpleEquals(){
		calculator.pressFive();
		calculator.pressThree();
		calculator.pressPlus();
		assertEquals(53, calculator.display());
		calculator.pressThree();
		assertEquals(3, calculator.display());
		calculator.pressFive();
		assertEquals(35, calculator.display());	
		calculator.pressEquals();
		assertEquals(88, calculator.display());	
	}
	
	@Test
	public void testComplexEquals(){
		calculator.pressFive();
		calculator.pressThree();
		calculator.pressPlus();
		calculator.pressThree();
		calculator.pressFive();
		calculator.pressEquals();
		assertEquals(88, calculator.display());	
		calculator.pressFive();
		assertEquals(5, calculator.display());	
		calculator.pressPlus();
		assertEquals(5, calculator.display());	
		calculator.pressThree();
		assertEquals(3, calculator.display());	
		calculator.pressEquals();
		assertEquals(8, calculator.display());			
	}
	
	@Test
	public void testSequentialOperators(){
		calculator.pressThree();
		calculator.pressPlus();
		assertEquals(3, calculator.display());
		calculator.pressThree();
		assertEquals(3, calculator.display());
		calculator.pressPlus();
		assertEquals(6, calculator.display());
		calculator.pressThree();
		assertEquals(3, calculator.display());
		calculator.pressEquals();
		assertEquals(9, calculator.display());
	}
	

}
